#!/bin/python
import os,sys,re
dryrun=False
reload(sys)  # Reload does the trick!
sys.setdefaultencoding('UTF8')
import fnmatch
import subprocess

from sickbeardstolen.parser import NameParser, InvalidNameException


ecache=[]

def getVideoLength(filename):
	if filename.strip() != '-':
		print "ohai:",filename
		result = subprocess.Popen(["ffprobe","-show_format","-of","json","-i",filename],
			stdout = subprocess.PIPE)  #, stderr = subprocess.STDOUT)
		return [x for x in result.stdout.readlines() if "duration" in x]
	else:
		return []


def recfind(dirname, globs):
	results=[]
	for root, dirnames, filenames in os.walk(dirname):
		for c in globs:
			for filename in fnmatch.filter(filenames, c):
				results.append(os.path.join(root, filename))
	return results


def detectMovie(myout,orig,source):
	# fallout for albums - any mp3's or m4a's or ogg's cause us to die
	# only do this on folders!
	#print source,myout
	if "/" in orig[1:]:
		# contians mp3s, and not a "large" number of videos - avoid moving dumps into music
		if (len(recfind(os.path.dirname(source), ["*.mp3","*.m4a","*.ogg","*.flac"])) > 2) and (len(recfind(os.path.dirname(source), ["*.avi","*.mkv","*.mpg"])) < 4):
			return "/Music"+myout

	isMovie=False
	# obviously, if it's in a movies folder, it's a movie.  DUh.
	if "/Movies" in orig or "/Named-Movies" in orig:
		isMovie=True
	if "aXXo" in orig:
		isMovie=True
	# movies generally have the yearin the pathname
	pathname=myout.split("/")[1]
	if re.match(".*[^0-9][0-9][0-9][0-9][0-9][^0-9].*", pathname.replace("1080","")):
		# we should check it's not a TV show, however!
		# i'm unsure how to do that... - but doctor.who.2005 would
		# match this!
		# i think abuse the tv show parser :)
		parser=NameParser()
		try:
			out=parser.parse(pathname)
		except InvalidNameException:
			out=None
		if out==None:
			isMovie=True
		
		if "/BBC" in myout:
			isMovie=False
		if "/PBS" in myout:
			isMovie=False
	
		# fallout for isMovie - if we have more than three video files, we're not a movie!
		if isMovie:
			allfound=[]
			if "/" in orig[1:]:
				allfound=recfind(os.path.dirname(source), ["*.avi","*.mkv","*.mpg"])
				if len(allfound) > 4:
					isMovie=False
			else:
				allfound=[source]
			print "checking",allfound
			if len(allfound)>0:
				duration=0
				for j in allfound:
					f=getVideoLength(j)
					if len(f)==1:
						nd=int(f[0].split()[1].replace('"',"").split(".")[0])
						if duration < nd:
							duration=nd
						print duration,j
				print duration
				# movies are at least 72 minutes, as per fuck you
				if duration < (60*72):
					isMovie=False
					
	if not isMovie:
		return "/TV"+myout
	else:
		return "/Movies"+myout

def detectTvShow(myout,orig):
	# consider only the path name for now
	pathname=myout.split("/")[1]

	# run through the sickbeard name parser
	parser=NameParser()
	
	#print "Possible TV:",pathname,"o",myout,orig
	try:
		out=parser.parse(pathname)
	except InvalidNameException:
		return myout
	if out==None or out.series_name==None:
		return myout

	# for now, just re-folder it
	f=myout
	try:
		f=u"/"+out.series_name.title()+myout
	except:
		pass
	return f
	

def foldTree(basefolder, includeFolders, replaceNames=[], exclude=[]):
	for p in includeFolders:
		for root, dirs, files in os.walk(p):
			for f in files:
				source=os.path.join(root,f)
				myout=source[len(p):]
				keep=True
				for j in exclude:
					if re.match(j, source, re.I):
						keep=False

				if keep:
					orig=myout
					# fold in foldnames
					for remove,replace in replaceNames:
						myout=re.sub(remove,replace,myout, re.I)

					# check if it's a tv show
					myout=detectTvShow(myout,orig)
					myout=detectMovie(myout,orig,source)

					myout=basefolder+myout
					dirname=os.path.dirname(myout)
					if not dirname in ecache:
						if not os.path.isdir(dirname):
							if not dryrun:
								os.makedirs(dirname)
							ecache.append(dirname)
					print source,"-->",myout
					if not dryrun:
						if os.path.islink(myout):
							os.unlink(myout)
						os.symlink(source, myout)

foldTree(
	basefolder="/merged/allvideos-new",

	#includeFolders=[
	#	"/bigish/data/complete",
	#	"/things/complete"
	#]
	includeFolders=[ "/moop",
		"/foop",
		"/bigish/data/complete",
		"/things/complete",
		"/newmyth/archive",
		"/localthings",
	 ],
	exclude=[ ".*incomplete.*" ],

	replaceNames=[
		# fold in paths
		["/usenet-complete-archive/", "/"],
		["/usenet/", "/"],
		["/rtorrent/", "/"],
		["/TV/", "/"],
		["/Movies/", "/"],
		["/complete/", "/"],
		["/videos-from-duck/", "/"],
		["/Named-Movies/", "/"],
		["/rtorrent-complete/", "/"],
		["/rtorrent-myth/", "/"],
		["/Movies-old/", "/"],
		["/jaymz-stuff/", "/"],
		["/tv-series/", "/"],

		# remove stupid torrent shite
		["/\{.*?\}[ -\.]*", "/"],
		["/\[.*?\][ -\.]*", "/"],
	],
)

